<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="问题主键" prop="questionId">
        <el-input
          v-model="queryParams.questionId"
          placeholder="请输入问题主键"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="选项" prop="opt">
        <el-input
          v-model="queryParams.opt"
          placeholder="请输入选项"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="问题选项" prop="result">
        <el-input
          v-model="queryParams.result"
          placeholder="请输入问题选项"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="是否删除" prop="isDel">
        <el-select v-model="queryParams.isDel" placeholder="请选择是否删除" clearable>
          <el-option
            v-for="dict in sys_is_del"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['manage:busExamQuestionResult:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['manage:busExamQuestionResult:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['manage:busExamQuestionResult:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['manage:busExamQuestionResult:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="busExamQuestionResultList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="主键" align="center" prop="id" />
      <el-table-column label="问题主键" align="center" prop="questionId" />
      <el-table-column label="选项" align="center" prop="opt" />
      <el-table-column label="问题选项" align="center" prop="result" />
      <el-table-column label="是否删除" align="center" prop="isDel">
        <template #default="scope">
          <dict-tag :options="sys_is_del" :value="scope.row.isDel"/>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['manage:busExamQuestionResult:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['manage:busExamQuestionResult:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改题库问题对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="busExamQuestionResultRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="问题主键" prop="questionId">
          <el-input v-model="form.questionId" placeholder="请输入问题主键" />
        </el-form-item>
        <el-form-item label="选项" prop="opt">
          <el-input v-model="form.opt" placeholder="请输入选项" />
        </el-form-item>
        <el-form-item label="问题选项" prop="result">
          <el-input v-model="form.result" placeholder="请输入问题选项" />
        </el-form-item>
        <el-form-item label="是否删除" prop="isDel">
          <el-select v-model="form.isDel" placeholder="请选择是否删除">
            <el-option
              v-for="dict in sys_is_del"
              :key="dict.value"
              :label="dict.label"
              :value="parseInt(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="BusExamQuestionResult">
import { listBusExamQuestionResult, getBusExamQuestionResult, delBusExamQuestionResult, addBusExamQuestionResult, updateBusExamQuestionResult } from "@/api/manage/busExamQuestionResult";

const { proxy } = getCurrentInstance();
const { sys_is_del } = proxy.useDict('sys_is_del');

const busExamQuestionResultList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    questionId: null,
    opt: null,
    result: null,
    isDel: null,
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询题库问题列表 */
function getList() {
  loading.value = true;
  listBusExamQuestionResult(queryParams.value).then(response => {
    busExamQuestionResultList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    questionId: null,
    opt: null,
    result: null,
    isDel: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("busExamQuestionResultRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加题库问题";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _id = row.id || ids.value
  getBusExamQuestionResult(_id).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改题库问题";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["busExamQuestionResultRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateBusExamQuestionResult(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBusExamQuestionResult(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value;
  proxy.$modal.confirm('是否确认删除题库问题编号为"' + _ids + '"的数据项？').then(function() {
    return delBusExamQuestionResult(_ids);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('manage/busExamQuestionResult/export', {
    ...queryParams.value
  }, `busExamQuestionResult_${new Date().getTime()}.xlsx`)
}

getList();
</script>
